# Concour

## Kind Popularity

- Titre
- Théme
- Date debut/fin
- Récompense
  - Manuelle
  - Automatique
    - Role
    - Message personalisé contenant ce que tu veux

### Déclarer un concour de popularité

1. Creer un channel
2. Préparer la récompense
3. Creer et configuré le concours de popularité dans le channel cible
   1. Creer : /concours-create kind:(string) title:(string) description:(string) fin:(date) (retourne l'id du concours)
   2. Changer les info : /concours-edit id:(object-id) banniere:(opt,string-url) title:(opt,string) description:(opt,string) fin:(date)
   3. Annoncer le concours : /concours-promo id:(object-id)
   4. Definir la récompense : /concours-set-recompense id:(object-id) kind:(string) content:(string,opt)
   5. Definir le channel : /concours-set-channel id:(object-id) channel-id:(u64)
   6. Cloturer le concours : /concours-end id:(object-id) fin:(date,opt)
   7. Annoncer le vainqueur : /concours-win id:(object-id) (si non finis, cloture le concours immédiatement)

### Sélectionner un vainqueur ?

Toute personne qui aura le plus d'émoji sur un message contenant une image

## Kind Automated Popularity

- Titre => String
- Description => String
- Date début => Date
- Periode (1 Semaine ?) => Duration
- CurrentWinner => Option<u64>
- RoleRécompense => u64
- KeyWordList => Vec<String>
- Banniére => Option<String>
- CurrentKeyWord => String
- Status => Enum<Created,Paused,OnGoing,Finished>
- HistoriqueWinner => HashMap<String,Option<(u64,Date)>>

### Command

- Creation /concours-create kind:(string) title:(string) description:(string) periode:(date)
- Start /concours-start
- List concours /concours-list

## Kind Check-in

Bot de concours avec participation reaction emoji